Index: LMDZ4/branches/V3_test/libf/dyn3dpar/guide_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/guide_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/guide_p.F	(revision 709)
@@ -82,10 +82,10 @@
       INTEGER step_rea,count_no_rea
 
-      real aire_min,aire_max
+c      real aire_min,aire_max
       integer ilon,ilat
       real factt,ztau(ip1jmp1)
 
       INTEGER itau,ij,l,i,j
-      integer ncidt,varidpl,nlev,status
+      integer ncidpl,varidpl,nlev,status
       integer rcod,rid 
       real ditau,tau,a
@@ -218,18 +218,35 @@
          step_rea=1
          count_no_rea=0
-
+         ncidpl=-99
 c    itau_test    montre si l'importation a deja ete faite au rang itau
 c lecture d'un fichier netcdf pour determiner le nombre de niveaux
-         if (mpi_rank==0) then
-	 ncidt=NCOPN('T.nc',NCNOWRIT,rcod)
+         IF (mpi_rank==0) THEN
+	
+         if (guide_u) then
+           if (ncidpl.eq.-99) ncidpl=NCOPN('u.nc',NCNOWRIT,rcod)
+         endif
+c
+         if (guide_v) then
+           if (ncidpl.eq.-99) ncidpl=NCOPN('v.nc',NCNOWRIT,rcod)
+         endif
+c
+         if (guide_T) then
+           if (ncidpl.eq.-99) ncidpl=NCOPN('T.nc',NCNOWRIT,rcod)
+         endif
+c
+         if (guide_Q) then
+           if (ncidpl.eq.-99) ncidpl=NCOPN('hur.nc',NCNOWRIT,rcod)
+         endif
+c
          if (ncep) then
-          status=NF_INQ_DIMID(ncidt,'LEVEL',rid)
+          status=NF_INQ_DIMID(ncidpl,'LEVEL',rid)
          else
-          status=NF_INQ_DIMID(ncidt,'PRESSURE',rid)
-         endif
-          status=NF_INQ_DIMLEN(ncidt,rid,nlev)
+          status=NF_INQ_DIMID(ncidpl,'PRESSURE',rid)
+         endif
+          status=NF_INQ_DIMLEN(ncidpl,rid,nlev)
          print *,'nlev', nlev 
-          call ncclos(ncidt,rcod)
-	 endif
+          call ncclos(ncidpl,rcod)
+	 
+	 ENDIF
 	 
 c   Lecture du premier etat des reanalyses.
@@ -338,6 +355,4 @@
       tau=tau-aint(tau)
 
-      print*,'ATTENTION !!!! ON NE GUIDE QUE JUSQU A 15N'
-
 c  ucov
       ijb=ij_begin
@@ -532,6 +547,9 @@
                zlat=rlatv(j)*180./pi
             endif
+          if (abs(grossismx-1.).lt.0.1.or.abs(grossismy-1.).lt.0.1) then
+c  pour une grille reguliere, xi=xxx**0=1 -> alpha=alphamin
+             alpha(i,j)=alphamin
+          else
             xi=((dxdy_max-dxdy_)/(dxdy_max-dxdy_min))**gamma
-c  pour une grille reguliere, xi=xxx**0=1 -> alpha=alphamin
             xi=min(xi,1.)
             if(lat_min_guide.le.zlat .and. zlat.le.lat_max_guide) then
@@ -540,4 +558,5 @@
                alpha(i,j)=0.
             endif
+          endif
          enddo
       enddo
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/iniadvtrac.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/iniadvtrac.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/iniadvtrac.F	(revision 709)
@@ -193,5 +193,9 @@
          str1=tnom(iq)
          tname(iiq)=tnom(iq)
-         ttext(iiq)=str1(1:lnblnk(str1))//descrq(iadv(iiq))
+         IF (iadv(iiq).eq.0) THEN
+           ttext(iiq)=str1(1:lnblnk(str1))
+         ELSE
+           ttext(iiq)=str1(1:lnblnk(str1))//descrq(iadv(iiq))
+         ENDIF
          str2=ttext(iiq)
 c   schemas tenant compte des moments d'ordre superieur.
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/integrd_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/integrd_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/integrd_p.F	(revision 709)
@@ -4,5 +4,5 @@
       SUBROUTINE integrd_p
      $  (  nq,vcovm1,ucovm1,tetam1,psm1,massem1,
-     $     dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps,masse,phis,finvmaold )
+     $     dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps0,masse,phis,finvmaold)
       USE parallel
       IMPLICIT NONE
@@ -41,5 +41,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm),teta(ip1jmp1,llm)
       REAL q(ip1jmp1,llm,nq)
-      REAL ps(ip1jmp1),masse(ip1jmp1,llm),phis(ip1jmp1)
+      REAL ps0(ip1jmp1),masse(ip1jmp1,llm),phis(ip1jmp1)
 
       REAL vcovm1(ip1jm,llm),ucovm1(ip1jmp1,llm)
@@ -55,5 +55,5 @@
       REAL vscr( ip1jm ),uscr( ip1jmp1 ),hscr( ip1jmp1 ),pscr(ip1jmp1)
       REAL massescr( ip1jmp1,llm ), finvmasse(ip1jmp1,llm)
-      REAL p(ip1jmp1,llmp1)
+      REAL,SAVE :: p(ip1jmp1,llmp1)
       REAL tpn,tps,tppn(iim),tpps(iim)
       REAL qpn,qps,qppn(iim),qpps(iim)
@@ -62,12 +62,12 @@
       INTEGER  l,ij,iq
 
-      EXTERNAL  filtreg,massdair,pression
-      EXTERNAL  SCOPY 
       REAL SSUM
       EXTERNAL SSUM
       INTEGER ijb,ije,jjb,jje
+      REAL,SAVE :: ps(ip1jmp1)
 c-----------------------------------------------------------------------
+     
       if (pole_nord) THEN
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
         DO  l = 1,llm
           DO  ij = 1,iip1
@@ -76,9 +76,9 @@
            ENDDO
         ENDDO
-      
+c$OMP END DO NOWAIT        
       ENDIF
 
       if (pole_sud) THEN
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
         DO  l = 1,llm
           DO  ij = 1,iip1
@@ -87,5 +87,5 @@
           ENDDO
         ENDDO
-      
+c$OMP END DO NOWAIT      
       ENDIF
 
@@ -96,8 +96,13 @@
       ijb=ij_begin
       ije=ij_end
-      massescr(ijb:ije,:)=masse(ijb:ije,:)
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
+      DO  l = 1,llm
+        massescr(ijb:ije,l)=masse(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT 
+
+c$OMP MASTER      
       DO 2 ij = ijb,ije
-       pscr (ij)    = ps(ij)
+       pscr (ij)    = ps0(ij)
        ps (ij)      = psm1(ij) + dt * dp(ij)
    2  CONTINUE
@@ -133,8 +138,12 @@
       
       ENDIF
+c$OMP END MASTER
+c$OMP BARRIER
 c
 c  ... Calcul  de la nouvelle masse d'air au dernier temps integre t+1 ...
 c
+
       CALL pression_p ( ip1jmp1, ap, bp, ps, p )
+c$OMP BARRIER
       CALL massdair_p (     p  , masse         )
 
@@ -142,5 +151,10 @@
       ijb=ij_begin
       ije=ij_end
-      finvmasse(ijb:ije,:)=masse(ijb:ije,:)
+      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
+      DO  l = 1,llm
+        finvmasse(ijb:ije,l)=masse(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
 
       jjb=jj_begin
@@ -151,4 +165,5 @@
 c    ............   integration  de  ucov, vcov,  h     ..............
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
       DO 10 l = 1,llm
       
@@ -225,5 +240,5 @@
 
   10  CONTINUE
-
+c$OMP END DO NOWAIT
 
 c
@@ -233,5 +248,5 @@
       ije=ij_end
       
-
+c$OMP MASTER
          DO l = 1, llm
           DO ij = ijb, ije
@@ -282,8 +297,15 @@
       
       ENDIF
+      
+c$OMP END MASTER
+c$OMP BARRIER
 
 c         CALL  SCOPY( ijp1llm , finvmasse, 1, finvmaold, 1 )
-      
-      finvmaold(ijb:ije,:)=finvmasse(ijb:ije,:)        
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l = 1, llm      
+        finvmaold(ijb:ije,l)=finvmasse(ijb:ije,l)        
+      ENDDO
+c$OMP END DO NOWAIT
 c
 c
@@ -292,4 +314,7 @@
 15    continue
 
+c$OMP MASTER
+        ps0(ijb:ije)=ps(ijb:ije)
+c$OMP END MASTER
 c    .................................................................
 
@@ -298,6 +323,13 @@
 c       CALL SCOPY (    ip1jmp1 ,  pscr   , 1,   psm1  , 1 )
 c       CALL SCOPY ( ip1jmp1*llm, massescr, 1,  massem1, 1 )
+c$OMP MASTER
         psm1(ijb:ije)=pscr(ijb:ije)
-        massem1(ijb:ije,:)=massescr(ijb:ije,:)
+c$OMP END MASTER
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+          DO l = 1, llm
+            massem1(ijb:ije,l)=massescr(ijb:ije,l)
+	  ENDDO
+c$OMP END DO NOWAIT	  
       END IF
 
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_gam_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_gam_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_gam_p.F	(revision 709)
@@ -31,8 +31,6 @@
 c    ......................................................
 
-      EXTERNAL  filtreg
-      EXTERNAL  SCOPY, grad, divergst
       INTEGER :: ijb,ije
-      
+      INTEGER :: l      
 c
 c
@@ -49,5 +47,10 @@
       if (pole_sud ) ije=ij_end
       
-      divgra(ijb:ije,klevel)=teta(ijb:ije,klevel)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l=1,klevel      
+        divgra(ijb:ije,l)=teta(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
+
 c
       CALL   grad_p ( klevel, divgra, ghx, ghy )
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_p.F	(revision 709)
@@ -21,4 +21,5 @@
       INTEGER klevel
       REAL teta( ip1jmp1,klevel ), divgra( ip1jmp1,klevel )
+      INTEGER :: l
 c
 c    ............     variables  locales      ..............
@@ -27,5 +28,4 @@
 c    .......................................................
 
-      EXTERNAL  SCOPY, grad, divergf, filtreg
       
       INTEGER :: ijb,ije,jjb,jje
@@ -37,6 +37,10 @@
       if (pole_nord) ijb=ij_begin
       if (pole_sud ) ije=ij_end
-      
-      divgra(ijb:ije,klevel)=teta(ijb:ije,klevel)
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l=1,klevel      
+        divgra(ijb:ije,l)=teta(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
       
       jjb=jj_begin-1
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_rot_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_rot_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_rot_p.F	(revision 709)
@@ -28,5 +28,4 @@
 c   ........................................................
 c
-      EXTERNAL  filtreg, nxgrad, rotatf
 c
       INTEGER :: ijb,ije,jjb,jje
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_rotgam_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_rotgam_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/laplacien_rotgam_p.F	(revision 709)
@@ -28,5 +28,4 @@
 c   ........................................................
 c
-      EXTERNAL   nxgrad_gam, rotat_nfil
       INTEGER :: ijb,ije
       
@@ -39,5 +38,5 @@
       ije=ij_end
       if(pole_sud) ije=ij_end-iip1
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO l = 1, klevel
         DO ij = ijb, ije
@@ -45,5 +44,5 @@
         ENDDO
       ENDDO
-
+c$OMP END DO NOWAIT
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/leapfrog_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/leapfrog_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/leapfrog_p.F	(revision 709)
@@ -1,3 +1,3 @@
-!
+! 
 ! $Header$
 !
@@ -75,4 +75,6 @@
 
 #include "academic.h"
+#include "clesphys.h"
+
       
       include 'mpif.h'
@@ -160,7 +162,7 @@
       REAL      d_h_vcol, d_qt, d_qw, d_ql, d_ec
       CHARACTER*15 ztit
-      INTEGER   ip_ebil_dyn  ! PRINT level for energy conserv. diag.
-      SAVE      ip_ebil_dyn
-      DATA      ip_ebil_dyn/0/
+!      INTEGER   ip_ebil_dyn  ! PRINT level for energy conserv. diag.
+!      SAVE      ip_ebil_dyn
+!      DATA      ip_ebil_dyn/0/
 c-jld 
 
@@ -198,5 +200,5 @@
       INTEGER :: iapptrac = 0
       INTEGER :: AdjustCount = 0
-      
+      INTEGER :: var_time
       ItCount=0
       
@@ -229,5 +231,5 @@
    1  CONTINUE
 
-      call MPI_BARRIER(MPI_COMM_WORLD,ierr)
+      call MPI_BARRIER(COMM_LMDZ,ierr)
 
 #ifdef CPP_IOIPSL
@@ -295,5 +297,5 @@
 
       ItCount=ItCount+1
-      if (MOD(ItCount,10000)==0) then
+      if (MOD(ItCount,1)==1) then
         debug=.true.
       else
@@ -315,5 +317,5 @@
       conser = .FALSE.
       apdiss = .FALSE.
-
+c      idissip=1
       IF( purmats ) THEN
          IF( MOD(itau,iconser) .EQ.0.AND.  forward    ) conser = .TRUE.
@@ -469,6 +471,6 @@
        call VTe(VThallo)
 
+      
       if (debug) then	
-             
         call WriteField_p('ucov',reshape(ucov,(/iip1,jmp1,llm/)))
         call WriteField_p('vcov',reshape(vcov,(/iip1,jjm,llm/)))
@@ -484,5 +486,5 @@
 c        enddo        
       endif
-      
+ 
 
       
@@ -497,9 +499,17 @@
       
       call VTb(VTcaldyn)
-      
+
+      var_time=time+iday-day_ini
+      OMP_CHUNK=5
+c$OMP PARALLEL DEFAULT(SHARED) 
+cc$OMP+         SHARED(itau,ucov,vcov,teta,ps,masse,pk,pkf,phis ,
+cc$OMP+                phi,conser,du,dv,dteta,dp,w, pbaru,pbarv, 
+cc$OMP+                var_time)      
+
       CALL caldyn_p 
      $  ( itau,ucov,vcov,teta,ps,masse,pk,pkf,phis ,
      $    phi,conser,du,dv,dteta,dp,w, pbaru,pbarv, time+iday-day_ini )
-      
+
+c$OMP END PARALLEL      
       call VTe(VTcaldyn)
 c      call WriteField_p('du',reshape(du,(/iip1,jmp1,llm/)))
@@ -516,5 +526,5 @@
 
       IF( forward. OR . leapf )  THEN
-
+c$OMP PARALLEL DEFAULT(SHARED) 
 c
 #ifdef INCA_CH4
@@ -530,12 +540,14 @@
      .             pk,iapptrac)
 #endif
+
+c$OMP END PARALLEL
+
 c      do j=1,nqmx
 c        call WriteField_p('q'//trim(int2str(j)),
-c    .                reshape(q(:,:,j),(/iip1,jmp1,llm/)))
+c     .                reshape(q(:,:,j),(/iip1,jmp1,llm/)))
 c        call WriteField_p('dq'//trim(int2str(j)),
 c     .                reshape(dq(:,:,j),(/iip1,jmp1,llm/)))
 c      enddo
-
-         IF (offline) THEN
+       IF (offline) THEN
 Cmaf stokage du flux de masse pour traceurs OFF-LINE
 
@@ -556,9 +568,31 @@
  
        call VTb(VTintegre)
+c      call WriteField_p('ucovm1',reshape(ucovm1,(/iip1,jmp1,llm/)))
+c      call WriteField_p('vcovm1',reshape(vcovm1,(/iip1,jjm,llm/)))
+c      call WriteField_p('tetam1',reshape(tetam1,(/iip1,jmp1,llm/)))
+c      call WriteField_p('psm1',reshape(psm1,(/iip1,jmp1/)))
+c      call WriteField_p('ucov',reshape(ucov,(/iip1,jmp1,llm/)))
+c      call WriteField_p('vcov',reshape(vcov,(/iip1,jjm,llm/)))
+c      call WriteField_p('teta',reshape(teta,(/iip1,jmp1,llm/)))
+c      call WriteField_p('ps',reshape(ps,(/iip1,jmp1/)))
+c$OMP PARALLEL DEFAULT(SHARED)
        CALL integrd_p ( 2,vcovm1,ucovm1,tetam1,psm1,massem1 ,
      $         dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps,masse,phis ,
      $              finvmaold                                    )
 
+c$OMP END PARALLEL
+c      call WriteField_p('ucovm1',reshape(ucovm1,(/iip1,jmp1,llm/)))
+c      call WriteField_p('vcovm1',reshape(vcovm1,(/iip1,jjm,llm/)))
+c      call WriteField_p('tetam1',reshape(tetam1,(/iip1,jmp1,llm/)))
+c      call WriteField_p('psm1',reshape(psm1,(/iip1,jmp1/)))
+c      call WriteField_p('ucov',reshape(ucov,(/iip1,jmp1,llm/)))
+c      call WriteField_p('vcov',reshape(vcov,(/iip1,jjm,llm/)))
+c      call WriteField_p('teta',reshape(teta,(/iip1,jmp1,llm/)))
+c      call WriteField_p('dteta',reshape(dteta,(/iip1,jmp1,llm/)))
+
+c      call WriteField_p('ps',reshape(ps,(/iip1,jmp1/)))
+ 
        call VTe(VTintegre)
+
 c .P.Le Van (26/04/94  ajout de  finvpold dans l'appel d'integrd)
 c
@@ -579,6 +613,12 @@
 c     .......   Ajout   P.Le Van ( 17/04/96 )   ...........
 c
+c$OMP PARALLEL DEFAULT(SHARED)
+c$OMP+         PRIVATE(rdaym_ini,rdayvrai,ijb,ije)
+
+c$OMP MASTER
          call suspend_timer(timer_caldyn)
          print*,'Entree dans la physique : Iteration No ',true_itau
+c$OMP END MASTER
+
          CALL pression_p (  ip1jmp1, ap, bp, ps,  p      )
          CALL exner_hyb_p(  ip1jmp1, ps, p,alpha,beta,pks, pk, pkf )
@@ -605,4 +645,6 @@
       ENDIF 
 c-jld
+c$OMP BARRIER
+c$OMP MASTER
         call VTb(VThallo)
         call SetTag(Request_physic,800)
@@ -650,4 +692,7 @@
 	
 	call VTb(VTphysiq)
+c$OMP END MASTER
+c$OMP BARRIER
+	
         CALL calfis_p( nq, lafin ,rdayvrai,time  ,
      $               ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
@@ -657,15 +702,23 @@
 #endif
      $               clesphy0, dufi,dvfi,dtetafi,dqfi,dpfi  )
-     
         ijb=ij_begin
         ije=ij_end  
         if ( .not. pole_nord) then
-          dufi_tmp(1:iip1,:)   = dufi(ijb:ijb+iim,:) 
-          dvfi_tmp(1:iip1,:)   = dvfi(ijb:ijb+iim,:)  
-          dtetafi_tmp(1:iip1,:)= dtetafi(ijb:ijb+iim,:)  
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+          DO l=1,llm
+          dufi_tmp(1:iip1,l)   = dufi(ijb:ijb+iim,l) 
+          dvfi_tmp(1:iip1,l)   = dvfi(ijb:ijb+iim,l)  
+          dtetafi_tmp(1:iip1,l)= dtetafi(ijb:ijb+iim,l)  
+          dqfi_tmp(1:iip1,l,:) = dqfi(ijb:ijb+iim,l,:)  
+          ENDDO
+c$OMP END DO NOWAIT
+
+c$OMP MASTER
           dpfi_tmp(1:iip1)     = dpfi(ijb:ijb+iim)  
-          dqfi_tmp(1:iip1,:,:) = dqfi(ijb:ijb+iim,:,:)  
-        endif
-        
+c$OMP END MASTER
+	endif
+
+c$OMP BARRIER
+c$OMP MASTER
 	call SetDistrib(jj_nb_Physic_bis)
 
@@ -695,20 +748,32 @@
  
         call SetDistrib(jj_nb_Physic)
-	
+c$OMP END MASTER
+c$OMP BARRIER	
 	        ijb=ij_begin
 	if (.not. pole_nord) then
-          dufi(ijb:ijb+iim,:) = dufi(ijb:ijb+iim,:)+dufi_tmp(1:iip1,:)
-          dvfi(ijb:ijb+iim,:) = dvfi(ijb:ijb+iim,:)+dvfi_tmp(1:iip1,:) 
-          dtetafi(ijb:ijb+iim,:) = dtetafi(ijb:ijb+iim,:)
-     &	                         +dtetafi_tmp(1:iip1,:)
+	
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+          DO l=1,llm
+            dufi(ijb:ijb+iim,l) = dufi(ijb:ijb+iim,l)+dufi_tmp(1:iip1,l)
+            dvfi(ijb:ijb+iim,l) = dvfi(ijb:ijb+iim,l)+dvfi_tmp(1:iip1,l) 
+            dtetafi(ijb:ijb+iim,l) = dtetafi(ijb:ijb+iim,l)
+     &                              +dtetafi_tmp(1:iip1,l)
+            dqfi(ijb:ijb+iim,l,:) = dqfi(ijb:ijb+iim,l,:)
+     &                              + dqfi_tmp(1:iip1,l,:)
+          ENDDO
+c$OMP END DO NOWAIT
+
+c$OMP MASTER
           dpfi(ijb:ijb+iim)   = dpfi(ijb:ijb+iim)+ dpfi_tmp(1:iip1)
-          dqfi(ijb:ijb+iim,:,:) = dqfi(ijb:ijb+iim,:,:)
-     &                           + dqfi_tmp(1:iip1,:,:)
+c$OMP END MASTER
+	  
         endif
-	
+c$OMP BARRIER
+cc$OMP MASTER	
 c      call WriteField_p('dufi',reshape(dufi,(/iip1,jmp1,llm/)))
 c      call WriteField_p('dvfi',reshape(dvfi,(/iip1,jjm,llm/)))
 c      call WriteField_p('dtetafi',reshape(dtetafi,(/iip1,jmp1,llm/)))
 c      call WriteField_p('dpfi',reshape(dpfi,(/iip1,jmp1/)))
+cc$OMP END MASTER
 c      
 c      do j=1,nqmx
@@ -723,4 +788,6 @@
      $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
 
+c$OMP BARRIER
+c$OMP MASTER
         call VTe(VTphysiq)
 
@@ -765,4 +832,6 @@
 
         call SetDistrib(jj_Nb_caldyn)
+c$OMP END MASTER
+c$OMP BARRIER
 c
 c  Diagnostique de conservation de l'énergie : difference
@@ -772,10 +841,13 @@
      e  , ucov    , vcov , ps, p ,pk , teta , q(:,:,1), q(:,:,2))
       ENDIF 
-      
-      if (debug) then
-       call WriteField_p('ucovfi',reshape(ucov,(/iip1,jmp1,llm/)))
-       call WriteField_p('vcovfi',reshape(vcov,(/iip1,jjm,llm/)))
-       call WriteField_p('tetafi',reshape(teta,(/iip1,jmp1,llm/)))
-      endif
+
+cc$OMP MASTER      
+c      if (debug) then
+c       call WriteField_p('ucovfi',reshape(ucov,(/iip1,jmp1,llm/)))
+c       call WriteField_p('vcovfi',reshape(vcov,(/iip1,jjm,llm/)))
+c       call WriteField_p('tetafi',reshape(teta,(/iip1,jmp1,llm/)))
+c      endif
+cc$OMP END MASTER
+
 #else
 
@@ -799,4 +871,5 @@
 
 c-jld
+c$OMP MASTER
          call resume_timer(timer_caldyn)
 	 if (FirstPhysic) then
@@ -804,4 +877,6 @@
 	   FirstPhysic=.false.
 	 endif
+c$OMP END MASTER
+c$OMP END PARALLEL
        ENDIF
 
@@ -815,4 +890,7 @@
 
       IF(apdiss) THEN
+c$OMP  PARALLEL DEFAULT(SHARED) 
+c$OMP+          PRIVATE(ijb,ije,tppn,tpn,tpps,tps)
+c$OMP MASTER
         call suspend_timer(timer_caldyn)
 	
@@ -822,5 +900,8 @@
 
         call VTb(VThallo)
-
+c$OMP END MASTER
+
+c$OMP BARRIER
+c$OMP MASTER
         call Register_SwapFieldHallo(ucov,ucov,ip1jmp1,llm,
      *                          jj_Nb_dissip,1,1,Request_dissip)
@@ -847,4 +928,7 @@
         
 	call start_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
+
         call covcont_p(llm,ucov,vcov,ucont,vcont)
         call enercin_p(vcov,ucov,vcont,ucont,ecin0)
@@ -853,12 +937,19 @@
 
         CALL dissip_p(vcov,ucov,teta,p,dvdis,dudis,dtetadis)
-        
+         
 	ijb=ij_begin
 	ije=ij_end
-	
-	ucov(ijb:ije,1:llm)=ucov(ijb:ije,1:llm)+dudis(ijb:ije,1:llm)
-        
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)	
+	DO l=1,llm
+	  ucov(ijb:ije,l)=ucov(ijb:ije,l)+dudis(ijb:ije,l)
+        ENDDO
+c$OMP END DO NOWAIT	
 	if (pole_sud) ije=ije-iip1
-	vcov(ijb:ije,1:llm)=vcov(ijb:ije,1:llm)+dvdis(ijb:ije,1:llm)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)	
+	DO l=1,llm
+	  vcov(ijb:ije,l)=vcov(ijb:ije,l)+dvdis(ijb:ije,l)
+        ENDDO
+c$OMP END DO NOWAIT	
+
 c       teta=teta+dtetadis
 
@@ -868,4 +959,6 @@
 C       On rajoute la tendance due a la transform. Ec -> E therm. cree
 C       lors de la dissipation
+c$OMP BARRIER
+c$OMP MASTER
             call suspend_timer(timer_dissip)
 	    call VTb(VThallo)
@@ -877,5 +970,6 @@
             call VTe(VThallo)
             call resume_timer(timer_dissip)
-	    
+c$OMP END MASTER
+c$OMP BARRIER	    
             call covcont_p(llm,ucov,vcov,ucont,vcont)
             call enercin_p(vcov,ucov,vcont,ucont,ecin)
@@ -883,5 +977,5 @@
 	    ijb=ij_begin
 	    ije=ij_end
-	    
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)	    
 	    do l=1,llm
 	      do ij=ijb,ije
@@ -890,10 +984,10 @@
               enddo
 	    enddo
-	    
+c$OMP END DO NOWAIT	    
        endif
 
        ijb=ij_begin
        ije=ij_end
-	    
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)	    
 	 do l=1,llm
 	   do ij=ijb,ije
@@ -901,5 +995,5 @@
 	   enddo
 	 enddo
-	 
+c$OMP END DO NOWAIT	 
 c------------------------------------------------------------------------
 
@@ -913,4 +1007,5 @@
          
         if (pole_nord) then
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
           DO l  =  1, llm
             DO ij =  1,iim
@@ -923,5 +1018,7 @@
             ENDDO
           ENDDO
-               
+c$OMP END DO NOWAIT
+
+c$OMP MASTER               
           DO ij =  1,iim
             tppn(ij)  = aire(  ij    ) * ps (  ij    )
@@ -932,7 +1029,9 @@
             ps(  ij    ) = tpn
           ENDDO
+c$OMP END MASTER
         endif
         
         if (pole_sud) then
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
           DO l  =  1, llm
             DO ij =  1,iim
@@ -945,5 +1044,7 @@
             ENDDO
           ENDDO
-               
+c$OMP END DO NOWAIT
+
+c$OMP MASTER               
           DO ij =  1,iim
             tpps(ij)  = aire(ij+ip1jm) * ps (ij+ip1jm)
@@ -954,6 +1055,10 @@
             ps(ij+ip1jm) = tps
           ENDDO
+c$OMP END MASTER
         endif
 
+
+c$OMP BARRIER
+c$OMP MASTER
         call VTe(VTdissipation)
 
@@ -983,4 +1088,6 @@
         call resume_timer(timer_caldyn)
 	print *,'fin dissipation'
+c$OMP END MASTER
+c$OMP END PARALLEL
       END IF
 
@@ -1066,14 +1173,7 @@
 
             IF( itau. EQ. itaufinp1 ) then  
-c$$$       write(79,*) 'ucov',ucov
-c$$$       write(80,*) 'vcov',vcov
-c$$$       write(81,*) 'teta',teta
-c$$$       write(82,*) 'ps',ps
-c$$$       write(83,*) 'q',q
-c$$$       WRITE(85,*) 'q1 = ',q(:,:,1)
-c$$$       WRITE(86,*) 'q3 = ',q(:,:,3)
-
+
+              call finalize_parallel
               abort_message = 'Simulation finished'
-
               call abort_gcm(modname,abort_message,0)
             ENDIF
@@ -1161,8 +1261,8 @@
 
 
-#ifdef CPP_IOIPSL
+c#ifdef CPP_IOIPSL
        CALL dynredem1_p("restart.nc",0.0,
      ,                     vcov,ucov,teta,q,nqmx,masse,ps)
-#endif
+c#endif
 
               CLOSE(99)
@@ -1218,4 +1318,5 @@
                forward =  .FALSE.
                IF( itau. EQ. itaufinp1 ) then  
+	         call finalize_parallel
                  abort_message = 'Simulation finished'
                  call abort_gcm(modname,abort_message,0)
@@ -1296,9 +1397,9 @@
                ENDIF
 
-#ifdef CPP_IOIPSL
+c#ifdef CPP_IOIPSL
                  IF(itau.EQ.itaufin)
      . CALL dynredem1_p("restart.nc",0.0,
      .                     vcov,ucov,teta,q,nqmx,masse,ps)
-#endif
+c#endif
 
                  forward = .TRUE.
@@ -1309,4 +1410,5 @@
       END IF
 
-      STOP
+        call finalize_parallel
+	STOP
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/limx.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/limx.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/limx.F	(revision 709)
@@ -48,6 +48,5 @@
       REAL      SSUM,CVMGP,CVMGT
       integer ismax,ismin
-      EXTERNAL  SSUM, convflu,ismin,ismax
-      EXTERNAL filtreg
+      EXTERNAL  SSUM, ismin,ismax
 
       data first/.true./
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/limy.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/limy.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/limy.F	(revision 709)
@@ -52,6 +52,5 @@
       REAL      SSUM
       integer ismax,ismin
-      EXTERNAL  SSUM, convflu,ismin,ismax
-      EXTERNAL filtreg
+      EXTERNAL  SSUM, ismin,ismax
 
       data first/.true./
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/limz.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/limz.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/limz.F	(revision 709)
@@ -48,6 +48,5 @@
       REAL      SSUM,CVMGP,CVMGT
       integer ismax,ismin
-      EXTERNAL  SSUM, convflu,ismin,ismax
-      EXTERNAL filtreg
+      EXTERNAL  SSUM, ismin,ismax
 
       data first/.true./
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/massbar_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/massbar_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/massbar_p.F	(revision 709)
@@ -76,5 +76,5 @@
       
       
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)  
       DO   100    l = 1 , llm
 c
@@ -112,4 +112,5 @@
 
 100   CONTINUE
+c$OMP END DO NOWAIT
 c
       RETURN
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/massbarxy_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/massbarxy_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/massbarxy_p.F	(revision 709)
@@ -31,4 +31,5 @@
       if (pole_sud)  ije=ije-iip1
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
       DO   100    l = 1 , llm
 c
@@ -49,4 +50,5 @@
 
 100   CONTINUE
+c$OMP END DO NOWAIT
 c
       RETURN
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/massdair_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/massdair_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/massdair_p.F	(revision 709)
@@ -92,4 +92,5 @@
       if (pole_sud)  ije=ij_end
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
       DO   100    l = 1 , llm
 c
@@ -114,4 +115,5 @@
        
 100   CONTINUE
+c$OMP END DO NOWAIT
 c
       RETURN
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/mod_hallo.F90
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/mod_hallo.F90	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/mod_hallo.F90	(revision 709)
@@ -385,7 +385,7 @@
 !         print *, 'process',MPI_RANK,'ISSEND: requette ',a_request%tag,'au process',rank,'de taille',SizeBuffer
 !         call MPI_ISSEND(Req%Buffer,SizeBuffer,MPI_REAL8,rank,a_request%tag,     &
-!                         MPI_COMM_WORLD,Req%MSG_Request,ierr)
+!                         COMM_LMDZ,Req%MSG_Request,ierr)
          call MPI_ISSEND(Buffer(req%Pos),SizeBuffer,MPI_REAL8,rank,a_request%tag,     &
-                         MPI_COMM_WORLD,Req%MSG_Request,ierr)
+                         COMM_LMDZ,Req%MSG_Request,ierr)
 
         endif
@@ -410,7 +410,7 @@
             
 !	    call MPI_IRECV(Req%Buffer,SizeBuffer,MPI_REAL8,rank,a_request%tag,     &
-!                           MPI_COMM_WORLD,Req%MSG_Request,ierr)
+!                           COMM_LMDZ,Req%MSG_Request,ierr)
 	    call MPI_IRECV(Buffer(Req%Pos),SizeBuffer,MPI_REAL8,rank,a_request%tag,     &
-                           MPI_COMM_WORLD,Req%MSG_Request,ierr)
+                           COMM_LMDZ,Req%MSG_Request,ierr)
 
           endif
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/nxgrad_gam_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/nxgrad_gam_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/nxgrad_gam_p.F	(revision 709)
@@ -22,4 +22,5 @@
       INTEGER :: ijb,ije
 c
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO 10 l = 1,klevel
 c
@@ -62,4 +63,5 @@
 c
   10  CONTINUE
+c$OMP END DO NOWAIT
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/nxgrad_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/nxgrad_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/nxgrad_p.F	(revision 709)
@@ -21,5 +21,5 @@
 c
 c
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO 10 l = 1,klevel
 c
@@ -63,4 +63,5 @@
 c
   10  CONTINUE
+c$OMP END DO NOWAIT
       RETURN
       END
